> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Matrix Totals Query



## OpenAPI

````yaml /openapi.json post /v1/workspaces/{workspaceId}/projects/{projectId}/item-slots/query/matrix-totals
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/projects/{projectId}/item-slots/query/matrix-totals:
    post:
      tags:
        - Project Item Slot Table Query
      summary: Matrix Totals Query
      operationId: ProjectItemSlotTableQueryController_matrixTotalsQuery_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
        - name: projectId
          required: true
          in: path
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ProjectItemSlotMatrixTotalsRequestDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProjectItemSlotMatrixTotalsResponseDto'
components:
  schemas:
    ProjectItemSlotMatrixTotalsRequestDto:
      type: object
      properties:
        configuration:
          type: object
          properties:
            schemaVersion:
              type: number
              enum:
                - 1
            columns:
              maxItems: 200
              type: array
              items:
                type: string
                minLength: 1
                maxLength: 255
            quickFilters:
              type: object
              properties:
                status:
                  maxItems: 20
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 255
                categoryIds:
                  maxItems: 100
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 255
                columnFilters:
                  maxItems: 50
                  type: array
                  items:
                    oneOf:
                      - type: object
                        properties:
                          fieldKey:
                            type: string
                            minLength: 1
                            maxLength: 255
                          type:
                            type: string
                            enum:
                              - text
                          value:
                            type: string
                            minLength: 1
                            maxLength: 1000
                          mode:
                            type: string
                            enum:
                              - contains
                              - equals
                        required:
                          - fieldKey
                          - type
                          - value
                          - mode
                        additionalProperties: false
                      - type: object
                        properties:
                          fieldKey:
                            type: string
                            minLength: 1
                            maxLength: 255
                          type:
                            type: string
                            enum:
                              - number
                          min:
                            type: string
                            pattern: ^-?(?:0|[1-9]\d{0,15})(?:\.\d{1,6})?$
                          max:
                            type: string
                            pattern: ^-?(?:0|[1-9]\d{0,15})(?:\.\d{1,6})?$
                        required:
                          - fieldKey
                          - type
                        additionalProperties: false
                      - type: object
                        properties:
                          fieldKey:
                            type: string
                            minLength: 1
                            maxLength: 255
                          type:
                            type: string
                            enum:
                              - boolean
                          value:
                            type: boolean
                        required:
                          - fieldKey
                          - type
                          - value
                        additionalProperties: false
                      - type: object
                        properties:
                          fieldKey:
                            type: string
                            minLength: 1
                            maxLength: 255
                          type:
                            type: string
                            enum:
                              - list
                          values:
                            minItems: 1
                            maxItems: 100
                            type: array
                            items:
                              type: string
                              minLength: 1
                              maxLength: 255
                        required:
                          - fieldKey
                          - type
                          - values
                        additionalProperties: false
                      - type: object
                        properties:
                          fieldKey:
                            type: string
                            minLength: 1
                            maxLength: 255
                          type:
                            type: string
                            enum:
                              - date
                          from:
                            type: string
                            format: date
                            pattern: >-
                              ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
                          to:
                            type: string
                            format: date
                            pattern: >-
                              ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
                        required:
                          - fieldKey
                          - type
                        additionalProperties: false
              required:
                - status
                - categoryIds
                - columnFilters
              additionalProperties: false
            advancedFilter:
              type: object
              properties:
                sets:
                  maxItems: 5
                  type: array
                  items:
                    type: object
                    properties:
                      conditions:
                        minItems: 1
                        maxItems: 10
                        type: array
                        items:
                          oneOf:
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - is_any_of
                                    - is_not_any_of
                                values:
                                  minItems: 1
                                  maxItems: 100
                                  type: array
                                  items:
                                    type: string
                                    minLength: 1
                                    maxLength: 255
                              required:
                                - fieldKey
                                - operator
                                - values
                              additionalProperties: false
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - contains
                                    - does_not_contain
                                value:
                                  type: string
                                  minLength: 1
                                  maxLength: 1000
                              required:
                                - fieldKey
                                - operator
                                - value
                              additionalProperties: false
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - number_eq
                                    - number_neq
                                    - number_gt
                                    - number_gte
                                    - number_lt
                                    - number_lte
                                value:
                                  type: string
                                  pattern: ^-?(?:0|[1-9]\d{0,15})(?:\.\d{1,6})?$
                              required:
                                - fieldKey
                                - operator
                                - value
                              additionalProperties: false
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - is_empty
                                    - is_not_empty
                              required:
                                - fieldKey
                                - operator
                              additionalProperties: false
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - date_on
                                    - date_before
                                    - date_after
                                value:
                                  type: string
                                  format: date
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
                              required:
                                - fieldKey
                                - operator
                                - value
                              additionalProperties: false
                            - type: object
                              properties:
                                fieldKey:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                operator:
                                  type: string
                                  enum:
                                    - date_between
                                from:
                                  type: string
                                  format: date
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
                                to:
                                  type: string
                                  format: date
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
                              required:
                                - fieldKey
                                - operator
                                - from
                                - to
                              additionalProperties: false
                    required:
                      - conditions
                    additionalProperties: false
              required:
                - sets
              additionalProperties: false
            groupBy:
              maxItems: 2
              type: array
              items:
                type: object
                properties:
                  fieldKey:
                    type: string
                    minLength: 1
                    maxLength: 255
                  direction:
                    type: string
                    enum:
                      - asc
                      - desc
                required:
                  - fieldKey
                  - direction
                additionalProperties: false
            sort:
              maxItems: 1
              type: array
              items:
                type: object
                properties:
                  fieldKey:
                    type: string
                    minLength: 1
                    maxLength: 255
                  direction:
                    type: string
                    enum:
                      - asc
                      - desc
                required:
                  - fieldKey
                  - direction
                additionalProperties: false
          required:
            - schemaVersion
            - columns
            - quickFilters
            - advancedFilter
            - groupBy
            - sort
          additionalProperties: false
        search:
          type: string
          minLength: 1
          maxLength: 255
        status:
          type: string
          enum:
            - new
            - ready
            - broken
        navigatorScope:
          oneOf:
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - area
                areaId:
                  type: string
                scope:
                  default: subtree
                  type: string
                  enum:
                    - direct
                    - subtree
              required:
                - kind
                - areaId
              additionalProperties: false
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - category
                categoryId:
                  type: string
              required:
                - kind
                - categoryId
              additionalProperties: false
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - special
                value:
                  type: string
                  enum:
                    - unassigned
                    - extra
              required:
                - kind
                - value
              additionalProperties: false
            - type: object
              properties:
                kind:
                  type: string
                  enum:
                    - path
                segments:
                  minItems: 1
                  maxItems: 10
                  type: array
                  items:
                    oneOf:
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - area
                          areaId:
                            type: string
                          scope:
                            type: string
                            enum:
                              - direct
                              - subtree
                        required:
                          - dimension
                          - areaId
                          - scope
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - area-type
                          areaTypeKey:
                            anyOf:
                              - type: string
                                pattern: ^[a-f0-9]{64}$
                              - type: 'null'
                        required:
                          - dimension
                          - areaTypeKey
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - area-level
                          levelKey:
                            type: string
                            format: uuid
                            pattern: >-
                              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          areaId:
                            type:
                              - string
                              - 'null'
                        required:
                          - dimension
                          - levelKey
                          - areaId
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - category
                          categoryId:
                            type: string
                        required:
                          - dimension
                          - categoryId
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - status
                          status:
                            type: string
                            enum:
                              - new
                              - ready
                              - broken
                        required:
                          - dimension
                          - status
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - supplier
                          supplierId:
                            type:
                              - string
                              - 'null'
                        required:
                          - dimension
                          - supplierId
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - finish
                          valueKey:
                            anyOf:
                              - type: string
                                pattern: ^[a-f0-9]{64}$
                              - type: 'null'
                        required:
                          - dimension
                          - valueKey
                        additionalProperties: false
                      - type: object
                        properties:
                          dimension:
                            type: string
                            enum:
                              - field
                          field:
                            type: string
                            maxLength: 200
                            pattern: >-
                              ^(?:system|catalog_family|catalog_item|catalog_family_source|catalog_item_source|project_item|project_item_slot):[a-zA-Z0-9_-]+$
                          value:
                            anyOf:
                              - type: string
                                minLength: 1
                                maxLength: 1000
                              - type: 'null'
                        required:
                          - dimension
                          - field
                          - value
                        additionalProperties: false
              required:
                - kind
                - segments
              additionalProperties: false
        changedSinceIssue:
          type: boolean
        changedInRange:
          type: object
          properties:
            from:
              type: string
              format: date
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
            to:
              type: string
              format: date
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$
            timeZone:
              default: UTC
              type: string
              minLength: 1
              maxLength: 64
          required:
            - from
            - to
          additionalProperties: false
      required:
        - configuration
      additionalProperties: false
    ProjectItemSlotMatrixTotalsResponseDto:
      type: object
      properties:
        structureVersion:
          anyOf:
            - type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            - type: 'null'
        lineCount:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        projectTotal:
          type: string
          pattern: ^-?\d+\.\d{6}$
          description: Exact decimal, six places
        unassigned:
          type: string
          pattern: ^-?\d+\.\d{6}$
          description: Exact decimal, six places
        extra:
          type: string
          pattern: ^-?\d+\.\d{6}$
          description: Exact decimal, six places
        areas:
          type: array
          items:
            type: object
            properties:
              areaId:
                type: string
              parentId:
                type:
                  - string
                  - 'null'
              level:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
              levelKey:
                type: string
              levelLabel:
                type: string
              code:
                type:
                  - string
                  - 'null'
              name:
                type: string
              multiplier:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
              instanceTags:
                anyOf:
                  - type: array
                    items:
                      type: string
                  - type: 'null'
              effectiveInstanceCount:
                type: string
              ancestorPath:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: string
                    code:
                      type:
                        - string
                        - 'null'
                    name:
                      type: string
                  required:
                    - id
                    - code
                    - name
                  additionalProperties: false
              effectiveQuantity:
                type: string
                pattern: ^-?\d+\.\d{6}$
                description: Exact decimal, six places
              subtreeEffectiveQuantity:
                type: string
                pattern: ^-?\d+\.\d{6}$
                description: Exact decimal, six places
            required:
              - areaId
              - parentId
              - level
              - levelKey
              - levelLabel
              - code
              - name
              - multiplier
              - instanceTags
              - effectiveInstanceCount
              - ancestorPath
              - effectiveQuantity
              - subtreeEffectiveQuantity
            additionalProperties: false
        rooms:
          type: array
          items:
            type: object
            properties:
              areaId:
                type: string
              roomIndex:
                type: integer
                minimum: 0
                maximum: 9007199254740991
              quantity:
                type: string
                pattern: ^-?\d+\.\d{6}$
                description: Exact decimal, six places
            required:
              - areaId
              - roomIndex
              - quantity
            additionalProperties: false
        listPriceTotals:
          type: array
          items:
            type: object
            properties:
              currency:
                type: string
              amount:
                type: string
                pattern: ^-?\d+\.\d{6}$
                description: Exact decimal, six places
              lineCount:
                type: integer
                minimum: 1
                maximum: 9007199254740991
            required:
              - currency
              - amount
              - lineCount
            additionalProperties: false
      required:
        - structureVersion
        - lineCount
        - projectTotal
        - unassigned
        - extra
        - areas
        - rooms
      additionalProperties: false

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.